com.hazelcast.com.fasterxml.jackson.core.filter

## Class FilteringGeneratorDelegate

- java.lang.Object
- - com.hazelcast.com.fasterxml.jackson.core.JsonGenerator
  - - com.hazelcast.com.fasterxml.jackson.core.util.JsonGeneratorDelegate
    - - com.hazelcast.com.fasterxml.jackson.core.filter.FilteringGeneratorDelegate

- All Implemented Interfaces:
    Versioned, Closeable, Flushable, AutoCloseable

      public class FilteringGeneratorDelegate
      extends JsonGeneratorDelegate

  Specialized `JsonGeneratorDelegate` that allows use of `TokenFilter` for outputting a subset of content that caller tries to generate.
  Since:
    2.6

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `JsonGenerator.Feature`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `_allowMultipleMatches` Flag that determines whether filtering will continue after the first match is indicated or not: if `false`, output is based on just the first full match (returning `TokenFilter.INCLUDE_ALL`) and no more checks are made; if `true` then filtering will be applied as necessary until end of content.
    `protected TokenFilterContext` | `_filterContext` Although delegate has its own output context it is not sufficient since we actually have to keep track of excluded (filtered out) structures as well as ones delegate actually outputs.
    `protected boolean` | `_includeImmediateParent` Deprecated.
    `protected boolean` | `_includePath` Flag that determines whether path leading up to included content should also be automatically included or not.
    `protected TokenFilter` | `_itemFilter` State that applies to the item within container, used where applicable.
    `protected int` | `_matchCount` Number of tokens for which `TokenFilter.INCLUDE_ALL` has been returned
    `protected TokenFilter` | `rootFilter` Object consulted to determine whether to write parts of content generator is asked to write or not.

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.util.JsonGeneratorDelegate

      `delegate, delegateCopyMethods`

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `_cfgPrettyPrinter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilteringGeneratorDelegate(JsonGenerator d, TokenFilter f, boolean includePath, boolean allowMultipleMatches)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `_checkBinaryWrite()`
    `protected void` | `_checkParentPath()`
    `protected void` | `_checkPropertyParentPath()` Specialized variant of `_checkParentPath()` used when checking parent for a property name to be included with value: rules are slightly different.
    `protected boolean` | `_checkRawValueWrite()`
    `TokenFilter` | `getFilter()`
    `JsonStreamContext` | `getFilterContext()`
    `int` | `getMatchCount()` Accessor for finding number of matches, where specific token and sub-tree starting (if structured type) are passed.
    `JsonStreamContext` | `getOutputContext()`
    `void` | `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
    `int` | `writeBinary(Base64Variant b64variant, InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
    `void` | `writeBoolean(boolean v)` Method for outputting literal JSON boolean value (one of Strings 'true' and 'false').
    `void` | `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
    `void` | `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
    `void` | `writeNull()` Method for outputting literal JSON null value.
    `void` | `writeNumber(BigDecimal v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(BigInteger v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(double v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(float v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(int v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(long v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(short v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
    `void` | `writeObjectId(Object id)` Method that can be called to output so-called native Object Id.
    `void` | `writeObjectRef(Object id)` Method that can be called to output references to native Object Ids.
    `void` | `writeOmittedField(String fieldName)` Method called to indicate that a property in this position was skipped.
    `void` | `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(SerializableString text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
    `void` | `writeRawValue(char[] text, int offset, int len)`
    `void` | `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
    `void` | `writeRawValue(String text, int offset, int len)`
    `void` | `writeStartArray()` Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartArray(int size)` Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.
    `void` | `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartObject(Object forValue)` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument.
    `void` | `writeString(char[] text, int offset, int len)` Method for outputting a String value.
    `void` | `writeString(SerializableString value)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
    `void` | `writeString(String value)` Method for outputting a String value.
    `void` | `writeTypeId(Object id)` Method that can be called to output so-called native Type Id.
    `void` | `writeUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.util.JsonGeneratorDelegate

      `canOmitFields, canUseSchema, canWriteBinaryNatively, canWriteObjectId, canWriteTypeId, close, copyCurrentEvent, copyCurrentStructure, disable, enable, flush, getCharacterEscapes, getCodec, getCurrentValue, getDelegate, getFeatureMask, getHighestEscapedChar, getOutputBuffered, getOutputTarget, getPrettyPrinter, getSchema, isClosed, isEnabled, overrideFormatFeatures, overrideStdFeatures, setCharacterEscapes, setCodec, setCurrentValue, setFeatureMask, setHighestNonEscapedChar, setPrettyPrinter, setRootValueSeparator, setSchema, useDefaultPrettyPrinter, version, writeArray, writeArray, writeArray, writeEmbeddedObject, writeFieldId, writeObject, writeString, writeTree`

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `_reportError, _reportUnsupportedOperation, _throwInternal, _verifyOffsets, _writeSimpleObject, canWriteFormattedNumbers, configure, getFormatFeatures, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeRawValue, writeStringField, writeTypePrefix, writeTypeSuffix`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### rootFilter

          protected TokenFilter rootFilter

      Object consulted to determine whether to write parts of content generator is asked to write or not.

    - #### _allowMultipleMatches

          protected boolean _allowMultipleMatches

      Flag that determines whether filtering will continue after the first match is indicated or not: if `false`, output is based on just the first full match (returning `TokenFilter.INCLUDE_ALL`) and no more checks are made; if `true` then filtering will be applied as necessary until end of content.

    - #### _includePath

          protected boolean _includePath

      Flag that determines whether path leading up to included content should also be automatically included or not. If `false`, no path inclusion is done and only explicitly included entries are output; if `true` then path from main level down to match is also included as necessary.

    - #### _includeImmediateParent

          @Deprecated
          protected boolean _includeImmediateParent

      Deprecated.

    - #### _filterContext

          protected TokenFilterContext _filterContext

      Although delegate has its own output context it is not sufficient since we actually have to keep track of excluded (filtered out) structures as well as ones delegate actually outputs.

    - #### _itemFilter

          protected TokenFilter _itemFilter

      State that applies to the item within container, used where applicable. Specifically used to pass inclusion state between property name and property, and also used for array elements.

    - #### _matchCount

          protected int _matchCount

      Number of tokens for which `TokenFilter.INCLUDE_ALL` has been returned

  - ### Constructor Detail

    - #### FilteringGeneratorDelegate

          public FilteringGeneratorDelegate(JsonGenerator d,
                                            TokenFilter f,
                                            boolean includePath,
                                            boolean allowMultipleMatches)

  - ### Method Detail

    - #### getFilter

          public TokenFilter getFilter()

    - #### getFilterContext

          public JsonStreamContext getFilterContext()

    - #### getMatchCount

          public int getMatchCount()

      Accessor for finding number of matches, where specific token and sub-tree starting (if structured type) are passed.

    - #### getOutputContext

          public JsonStreamContext getOutputContext()

      Overrides:
        `getOutputContext` in class `JsonGeneratorDelegate`
      Returns:
        Context object that can give information about logical position within generated json content.

    - #### writeStartArray

          public void writeStartArray()
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).

      Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartArray` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeStartArray

          public void writeStartArray(int size)
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.

      Default implementation simply calls `JsonGenerator.writeStartArray()`.

      Overrides:
        `writeStartArray` in class `JsonGeneratorDelegate`
      Parameters:
        `size` - Number of elements this array will have: actual number of values written (before matching call to `JsonGenerator.writeEndArray()` MUST match; generator MAY verify this is the case.
      Throws:
        `IOException`

    - #### writeEndArray

          public void writeEndArray()
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Array.

      Overrides:
        `writeEndArray` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeStartObject

          public void writeStartObject()
                                throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartObject` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeStartObject

          public void writeStartObject(Object forValue)
                                throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized.

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartObject` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeEndObject

          public void writeEndObject()
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

      Overrides:
        `writeEndObject` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeFieldName

          public void writeFieldName(String name)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

      Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

      Overrides:
        `writeFieldName` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeFieldName

          public void writeFieldName(SerializableString name)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

      Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

      Overrides:
        `writeFieldName` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(String value)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Overrides:
        `writeString` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(char[] text,
                                  int offset,
                                  int len)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Overrides:
        `writeString` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(SerializableString value)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

      Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

      Overrides:
        `writeString` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRawUTF8String

          public void writeRawUTF8String(byte[] text,
                                         int offset,
                                         int length)
                                  throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Overrides:
        `writeRawUTF8String` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeUTF8String

          public void writeUTF8String(byte[] text,
                                      int offset,
                                      int length)
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Overrides:
        `writeUTF8String` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(String text)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Overrides:
        `writeRaw` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(String text,
                               int offset,
                               int len)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Overrides:
        `writeRaw` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(SerializableString text)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      The default implementation delegates to `JsonGenerator.writeRaw(String)`; other backends that support raw inclusion of text are encouraged to implement it in more efficient manner (especially if they use UTF-8 encoding).

      Overrides:
        `writeRaw` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(char[] text,
                               int offset,
                               int len)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Overrides:
        `writeRaw` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(char c)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Overrides:
        `writeRaw` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(String text)
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.
      Overrides:
        `writeRawValue` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(String text,
                                    int offset,
                                    int len)
                             throws IOException

      Overrides:
        `writeRawValue` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(char[] text,
                                    int offset,
                                    int len)
                             throws IOException

      Overrides:
        `writeRawValue` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeBinary

          public void writeBinary(Base64Variant b64variant,
                                  byte[] data,
                                  int offset,
                                  int len)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

      Note: because JSON Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

      Overrides:
        `writeBinary` in class `JsonGeneratorDelegate`
      Parameters:
        `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
      Throws:
        `IOException`

    - #### writeBinary

          public int writeBinary(Base64Variant b64variant,
                                 InputStream data,
                                 int dataLength)
                          throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
      Overrides:
        `writeBinary` in class `JsonGeneratorDelegate`
      Parameters:
        `b64variant` - Base64 variant to use
        `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
        `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
      Returns:
        Number of bytes read from `data` and written as binary payload
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(short v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(int v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(long v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(BigInteger v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(double v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(float v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(BigDecimal v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(String encodedValue)
                           throws IOException,
                                  UnsupportedOperationException

      Description copied from class: `JsonGenerator`
      Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

      Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary JSON format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or JSON nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

      Overrides:
        `writeNumber` in class `JsonGeneratorDelegate`
      Throws:
        `UnsupportedOperationException` - If underlying data format does not support numbers serialized textually AND if generator is not allowed to just output a String instead (Schema-based formats may require actual number, for example)
        `IOException`

    - #### writeBoolean

          public void writeBoolean(boolean v)
                            throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeBoolean` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeNull

          public void writeNull()
                         throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNull` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeOmittedField

          public void writeOmittedField(String fieldName)
                                 throws IOException

      Description copied from class: `JsonGenerator`
      Method called to indicate that a property in this position was skipped. It is usually only called for generators that return `false` from `JsonGenerator.canOmitFields()`.

      Default implementation does nothing.

      Overrides:
        `writeOmittedField` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeObjectId

          public void writeObjectId(Object id)
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output so-called native Object Id. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeObjectId` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeObjectRef

          public void writeObjectRef(Object id)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output references to native Object Ids. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeObjectRef` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### writeTypeId

          public void writeTypeId(Object id)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output so-called native Type Id. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteTypeId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeTypeId` in class `JsonGeneratorDelegate`
      Throws:
        `IOException`

    - #### _checkParentPath

          protected void _checkParentPath()
                                   throws IOException

      Throws:
        `IOException`

    - #### _checkPropertyParentPath

          protected void _checkPropertyParentPath()
                                           throws IOException

      Specialized variant of `_checkParentPath()` used when checking parent for a property name to be included with value: rules are slightly different.
      Throws:
        `IOException`

    - #### _checkBinaryWrite

          protected boolean _checkBinaryWrite()
                                       throws IOException

      Throws:
        `IOException`

    - #### _checkRawValueWrite

          protected boolean _checkRawValueWrite()
                                         throws IOException

      Throws:
        `IOException`

Copyright © 2019. All rights reserved.